opal/class/opal_list.h File Reference.TH "opal/class/opal_list.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/class/opal_list.h \- The opal_list_t interface is used to provide a generic doubly-linked list container for Open MPI. 
.SH SYNOPSIS
.br
.PP
\fC#include <stdio.h>\fP
.br
\fC#include <stdlib.h>\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBopal_list_get_next\fP(item)   ((item) ? ((\fBopal_list_item_t\fP*) ((\fBopal_list_item_t\fP*)(item))->opal_list_next) : NULL)"
.br
.RI "\fIGet the next item in a list. \fP"
.ti -1c
.RI "#define \fBopal_list_get_prev\fP(item)   ((item) ? ((\fBopal_list_item_t\fP*) ((\fBopal_list_item_t\fP*)(item))->opal_list_prev) : NULL)"
.br
.RI "\fIGet the next item in a list. \fP"
.ti -1c
.RI "#define \fBopal_list_append\fP(l, i)   _opal_list_append(l,i)"
.br
.RI "\fIAppend an item to the end of the list. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBopal_list_item_t\fP \fBopal_list_item_t\fP"
.br
.RI "\fIBase type for items that are put in a list (opal_list_t) containers. \fP"
.ti -1c
.RI "typedef \fBopal_list_t\fP \fBopal_list_t\fP"
.br
.RI "\fIList container type. \fP"
.ti -1c
.RI "typedef int(* \fBopal_list_item_compare_fn_t\fP )(\fBopal_list_item_t\fP **a, \fBopal_list_item_t\fP **b)"
.br
.RI "\fIComparison function for \fBopal_list_sort()\fP, below. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (\fBopal_list_t\fP)"
.br
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (\fBopal_list_item_t\fP)"
.br
.ti -1c
.RI "static bool \fBopal_list_is_empty\fP (\fBopal_list_t\fP *list)"
.br
.RI "\fICheck for empty list. \fP"
.ti -1c
.RI "static \fBopal_list_item_t\fP * \fBopal_list_get_first\fP (\fBopal_list_t\fP *list)"
.br
.RI "\fIReturn the first item on the list (does not remove it). \fP"
.ti -1c
.RI "static \fBopal_list_item_t\fP * \fBopal_list_get_last\fP (\fBopal_list_t\fP *list)"
.br
.RI "\fIReturn the last item on the list (does not remove it). \fP"
.ti -1c
.RI "static \fBopal_list_item_t\fP * \fBopal_list_get_begin\fP (\fBopal_list_t\fP *list)"
.br
.RI "\fIReturn the beginning of the list; an invalid list entry suitable for comparison only. \fP"
.ti -1c
.RI "static \fBopal_list_item_t\fP * \fBopal_list_get_end\fP (\fBopal_list_t\fP *list)"
.br
.RI "\fIReturn the end of the list; an invalid list entry suitable for comparison only. \fP"
.ti -1c
.RI "static size_t \fBopal_list_get_size\fP (\fBopal_list_t\fP *list)"
.br
.RI "\fIReturn the number of items in a list. \fP"
.ti -1c
.RI "static \fBopal_list_item_t\fP * \fBopal_list_remove_item\fP (\fBopal_list_t\fP *list, \fBopal_list_item_t\fP *item)"
.br
.RI "\fIRemove an item from a list. \fP"
.ti -1c
.RI "static void \fB_opal_list_append\fP (\fBopal_list_t\fP *list, \fBopal_list_item_t\fP *item)"
.br
.ti -1c
.RI "static void \fBopal_list_prepend\fP (\fBopal_list_t\fP *list, \fBopal_list_item_t\fP *item)"
.br
.RI "\fIPrepend an item to the beginning of the list. \fP"
.ti -1c
.RI "static \fBopal_list_item_t\fP * \fBopal_list_remove_first\fP (\fBopal_list_t\fP *list)"
.br
.RI "\fIRemove the first item from the list and return it. \fP"
.ti -1c
.RI "static \fBopal_list_item_t\fP * \fBopal_list_remove_last\fP (\fBopal_list_t\fP *list)"
.br
.RI "\fIRemove the last item from the list and return it. \fP"
.ti -1c
.RI "static void \fBopal_list_insert_pos\fP (\fBopal_list_t\fP *list, \fBopal_list_item_t\fP *pos, \fBopal_list_item_t\fP *item)"
.br
.RI "\fIAdd an item to the list before a given element. \fP"
.ti -1c
.RI "bool \fBopal_list_insert\fP (\fBopal_list_t\fP *list, \fBopal_list_item_t\fP *item, long long idx)"
.br
.RI "\fIAdd an item to the list at a specific index location in the list. \fP"
.ti -1c
.RI "void \fBopal_list_join\fP (\fBopal_list_t\fP *thislist, \fBopal_list_item_t\fP *pos, \fBopal_list_t\fP *xlist)"
.br
.RI "\fIJoin a list into another list. \fP"
.ti -1c
.RI "void \fBopal_list_splice\fP (\fBopal_list_t\fP *thislist, \fBopal_list_item_t\fP *pos, \fBopal_list_t\fP *xlist, \fBopal_list_item_t\fP *first, \fBopal_list_item_t\fP *last)"
.br
.RI "\fISplice a list into another list. \fP"
.ti -1c
.RI "int \fBopal_list_sort\fP (\fBopal_list_t\fP *list, \fBopal_list_item_compare_fn_t\fP compare)"
.br
.RI "\fISort a list with a provided compare function. \fP"
.in -1c
.SH "Detailed Description"
.PP 
The opal_list_t interface is used to provide a generic doubly-linked list container for Open MPI. 

It was inspired by (but is slightly different than) the Stantard Template Library (STL) std::list class. One notable difference from std::list is that when an opal_list_t is destroyed, all of the opal_list_item_t objects that it contains are orphaned -- they are \fInot\fP destroyed.
.PP
The general idea is that opal_list_item_t objects can be put on an opal_list_t. Hence, you create a new type that derives from opal_list_item_t; this new type can then be used with opal_list_t containers.
.PP
NOTE: opal_list_item_t instances can only be on \fIone\fP list at a time. Specifically, if you add an opal_list_item_t to one list, and then add it to another list (without first removing it from the first list), you will effectively be hosing the first list. You have been warned.
.PP
If OMPI_ENABLE_DEBUG is true, a bunch of checks occur, including some spot checks for a debugging reference count in an attempt to ensure that an opal_list_item_t is only one *one* list at a time. Given the highly concurrent nature of this class, these spot checks cannot guarantee that an item is only one list at a time. Specifically, since it is a desirable attribute of this class to not use locks for normal operations, it is possible that two threads may [erroneously] modify an opal_list_item_t concurrently.
.PP
The only way to guarantee that a debugging reference count is valid for the duration of an operation is to lock the item_t during the operation. But this fundamentally changes the desirable attribute of this class (i.e., no locks). So all we can do is spot-check the reference count in a bunch of places and check that it is still the value that we think it should be. But this doesn't mean that you can run into 'unlucky' cases where two threads are concurrently modifying an item_t, but all the spot checks still return the 'right' values. All we can do is hope that we have enough spot checks to statistically drive down the possibility of the unlucky cases happening.
.SH "Define Documentation"
.PP 
.SS "#define opal_list_append(l, i)   _opal_list_append(l,i)"
.PP
Append an item to the end of the list. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container 
.br
\fIitem\fP The item to append
.RE
.PP
This is an O(1) operation to append an item to the end of a list. The opal_list_item_t is not \fBOBJ_RETAIN()\fP'ed; it is assumed that 'ownership' of the item is passed from the caller to the list.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation. 
.SS "#define opal_list_get_next(item)   ((item) ? ((\fBopal_list_item_t\fP*) ((\fBopal_list_item_t\fP*)(item))->opal_list_next) : NULL)"
.PP
Get the next item in a list. 
.PP
\fBParameters:\fP
.RS 4
\fIitem\fP A list item.
.RE
.PP
\fBReturns:\fP
.RS 4
The next item in the list 
.RE
.PP

.SS "#define opal_list_get_prev(item)   ((item) ? ((\fBopal_list_item_t\fP*) ((\fBopal_list_item_t\fP*)(item))->opal_list_prev) : NULL)"
.PP
Get the next item in a list. 
.PP
\fBParameters:\fP
.RS 4
\fIitem\fP A list item.
.RE
.PP
\fBReturns:\fP
.RS 4
The next item in the list 
.RE
.PP

.SH "Typedef Documentation"
.PP 
.SS "typedef int(* \fBopal_list_item_compare_fn_t\fP)(\fBopal_list_item_t\fP **a, \fBopal_list_item_t\fP **b)"
.PP
Comparison function for \fBopal_list_sort()\fP, below. 
.PP
\fBParameters:\fP
.RS 4
\fIa\fP Pointer to a pointer to an opal_list_item_t. Explanation below. 
.br
\fIb\fP Pointer to a pointer to an opal_list_item_t. Explanation below. 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI1\fP if \fIa\fP is greater than \fIb\fP 
.br
\fI0\fP if \fIa\fP is equal to \fIb\fP 
.br
\fI11\fP if \fIa\fP is less than \fIb\fP 
.RE
.PP
This function is invoked by qsort(3) from within \fBopal_list_sort()\fP. It is important to understand what \fBopal_list_sort()\fP does before invoking qsort, so go read that documentation first.
.PP
The important thing to realize here is that a and b will be \fIdouble\fP pointers to the items that you need to compare. Here's a sample compare function to illustrate this point:
.PP
static int compare(opal_list_item_t **a, opal_list_item_t **b) { \fBorte_pls_base_cmp_t\fP *aa = *((\fBorte_pls_base_cmp_t\fP **) a); \fBorte_pls_base_cmp_t\fP *bb = *((\fBorte_pls_base_cmp_t\fP **) b);
.PP
if (bb->priority > aa->priority) { return 1; } else if (bb->priority == aa->priority) { return 0; } else { return -1; } }  
.SH "Function Documentation"
.PP 
.SS "static \fBopal_list_item_t\fP* opal_list_get_begin (\fBopal_list_t\fP * list)\fC [inline, static]\fP"
.PP
Return the beginning of the list; an invalid list entry suitable for comparison only. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container
.RE
.PP
\fBReturns:\fP
.RS 4
A pointer to the beginning of the list.
.RE
.PP
This is an O(1) operation to return the beginning of the list. Similar to the STL, this is a special invalid list item -- it should \fInot\fP be used for storage. It is only suitable for comparison to other items in the list to see if they are valid or not; it's ususally used when iterating through the items in a list.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation. 
.SS "static \fBopal_list_item_t\fP* opal_list_get_end (\fBopal_list_t\fP * list)\fC [inline, static]\fP"
.PP
Return the end of the list; an invalid list entry suitable for comparison only. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container
.RE
.PP
\fBReturns:\fP
.RS 4
A pointer to the end of the list.
.RE
.PP
This is an O(1) operation to return the end of the list. Similar to the STL, this is a special invalid list item -- it should \fInot\fP be used for storage. It is only suitable for comparison to other items in the list to see if they are valid or not; it's ususally used when iterating through the items in a list.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation. 
.SS "static \fBopal_list_item_t\fP* opal_list_get_first (\fBopal_list_t\fP * list)\fC [inline, static]\fP"
.PP
Return the first item on the list (does not remove it). 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container
.RE
.PP
\fBReturns:\fP
.RS 4
A pointer to the first item on the list
.RE
.PP
This is an O(1) operation to return the first item on the list. It should be compared against the returned value from \fBopal_list_get_end()\fP to ensure that the list is not empty.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation. 
.SS "static \fBopal_list_item_t\fP* opal_list_get_last (\fBopal_list_t\fP * list)\fC [inline, static]\fP"
.PP
Return the last item on the list (does not remove it). 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container
.RE
.PP
\fBReturns:\fP
.RS 4
A pointer to the last item on the list
.RE
.PP
This is an O(1) operation to return the last item on the list. It should be compared against the returned value from \fBopal_list_get_begin()\fP to ensure that the list is not empty.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation. 
.SS "static size_t opal_list_get_size (\fBopal_list_t\fP * list)\fC [inline, static]\fP"
.PP
Return the number of items in a list. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container
.RE
.PP
\fBReturns:\fP
.RS 4
The size of the list (size_t)
.RE
.PP
This is an O(1) lookup to return the size of the list.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation.
.PP
\fBWarning:\fP
.RS 4
The size of the list is cached as part of the list. In the future, calling \fCopal_list_splice\fP or \fCopal_list_join\fP may result in this function recomputing the list size, which would be an O(N) operation. If \fCopal_list_splice\fP or \fCopal_list_join\fP is never called on the specified list, this function will always be O(1). 
.RE
.PP

.SS "bool opal_list_insert (\fBopal_list_t\fP * list, \fBopal_list_item_t\fP * item, long long idx)"
.PP
Add an item to the list at a specific index location in the list. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container 
.br
\fIitem\fP The item to insert 
.br
\fIindex\fP Location to add the item
.RE
.PP
\fBReturns:\fP
.RS 4
true if insertion succeeded; otherwise false
.RE
.PP
This is potentially an O(N) operation to traverse down to the correct location in the list and add an item.
.PP
Example: if idx = 2 and list = item1->item2->item3->item4, then after insert, list = item1->item2->item->item3->item4.
.PP
If index is greater than the length of the list, no action is performed and false is returned. 
.SS "static void opal_list_insert_pos (\fBopal_list_t\fP * list, \fBopal_list_item_t\fP * pos, \fBopal_list_item_t\fP * item)\fC [inline, static]\fP"
.PP
Add an item to the list before a given element. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container 
.br
\fIpos\fP List element to insert \fCitem\fP before 
.br
\fIitem\fP The item to insert
.RE
.PP
Inserts \fCitem\fP before \fCpos\fP. This is an O(1) operation. 
.SS "static bool opal_list_is_empty (\fBopal_list_t\fP * list)\fC [inline, static]\fP"
.PP
Check for empty list. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container
.RE
.PP
\fBReturns:\fP
.RS 4
true if list's size is 0, false otherwise
.RE
.PP
This is an O(1) operation.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation. 
.SS "void opal_list_join (\fBopal_list_t\fP * thislist, \fBopal_list_item_t\fP * pos, \fBopal_list_t\fP * xlist)"
.PP
Join a list into another list. 
.PP
\fBParameters:\fP
.RS 4
\fIthislist\fP List container for list being operated on 
.br
\fIpos\fP List item in \fCthislist\fP marking the position before which items are inserted 
.br
\fIxlist\fP List container for list being spliced from
.RE
.PP
Join a list into another list. All of the elements of \fCxlist\fP are inserted before \fCpos\fP and removed from \fCxlist\fP.
.PP
This operation is an O(1) operation. Both \fCthislist\fP and \fCxlist\fP must be valid list containsers. \fCxlist\fP will be empty but valid after the call. All pointers to \fCopal_list_item_t\fP containers remain valid, including those that point to elements in \fCxlist\fP. 
.SS "static void opal_list_prepend (\fBopal_list_t\fP * list, \fBopal_list_item_t\fP * item)\fC [inline, static]\fP"
.PP
Prepend an item to the beginning of the list. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container 
.br
\fIitem\fP The item to prepend
.RE
.PP
This is an O(1) operation to prepend an item to the beginning of a list. The opal_list_item_t is not \fBOBJ_RETAIN()\fP'ed; it is assumed that 'ownership' of the item is passed from the caller to the list.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation. 
.SS "static \fBopal_list_item_t\fP* opal_list_remove_first (\fBopal_list_t\fP * list)\fC [inline, static]\fP"
.PP
Remove the first item from the list and return it. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container
.RE
.PP
\fBReturns:\fP
.RS 4
The first item on the list. If the list is empty, NULL will be returned
.RE
.PP
This is an O(1) operation to return the first item on the list. If the list is not empty, a pointer to the first item in the list will be returned. Ownership of the item is transferred from the list to the caller; no calls to \fBOBJ_RETAIN()\fP or \fBOBJ_RELEASE()\fP are invoked.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation. 
.SS "static \fBopal_list_item_t\fP* opal_list_remove_item (\fBopal_list_t\fP * list, \fBopal_list_item_t\fP * item)\fC [inline, static]\fP"
.PP
Remove an item from a list. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container 
.br
\fIitem\fP The item to remove
.RE
.PP
\fBReturns:\fP
.RS 4
A pointer to the item on the list previous to the one that was removed.
.RE
.PP
This is an O(1) operation to remove an item from the list. The forward / reverse pointers in the list are updated and the item is removed. The list item that is returned is now 'owned' by the caller -- they are responsible for \fBOBJ_RELEASE()\fP'ing it.
.PP
If debugging is enabled (specifically, if --enable-debug was used to configure Open MPI), this is an O(N) operation because it checks to see if the item is actually in the list first.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation. 
.SS "static \fBopal_list_item_t\fP* opal_list_remove_last (\fBopal_list_t\fP * list)\fC [inline, static]\fP"
.PP
Remove the last item from the list and return it. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list container
.RE
.PP
\fBReturns:\fP
.RS 4
The last item on the list. If the list is empty, NULL will be returned
.RE
.PP
This is an O(1) operation to return the last item on the list. If the list is not empty, a pointer to the last item in the list will be returned. Ownership of the item is transferred from the list to the caller; no calls to \fBOBJ_RETAIN()\fP or \fBOBJ_RELEASE()\fP are invoked.
.PP
This is an inlined function in compilers that support inlining, so it's usually a cheap operation. 
.SS "int opal_list_sort (\fBopal_list_t\fP * list, \fBopal_list_item_compare_fn_t\fP compare)"
.PP
Sort a list with a provided compare function. 
.PP
\fBParameters:\fP
.RS 4
\fIlist\fP The list to sort 
.br
\fIcompare\fP Compare function
.RE
.PP
Put crassly, this function's complexity is O(N) + O(log(N)). Its algorithm is:
.PP
.IP "\(bu" 2
remove every item from the list and put the corresponding (opal_list_item_t*)'s in an array
.IP "\(bu" 2
call qsort(3) with that array and your compare function
.IP "\(bu" 2
re-add every element of the now-sorted array to the list
.PP
.PP
The resulting list is now ordered. Note, however, that since an array of pointers is sorted, the comparison function must do a double de-reference to get to the actual opal_list_item_t (or whatever the underlying type is). See the documentation of opal_list_item_compare_fn_t for an example). 
.SS "void opal_list_splice (\fBopal_list_t\fP * thislist, \fBopal_list_item_t\fP * pos, \fBopal_list_t\fP * xlist, \fBopal_list_item_t\fP * first, \fBopal_list_item_t\fP * last)"
.PP
Splice a list into another list. 
.PP
\fBParameters:\fP
.RS 4
\fIthislist\fP List container for list being operated on 
.br
\fIpos\fP List item in \fCthislist\fP marking the position before which items are inserted 
.br
\fIxlist\fP List container for list being spliced from 
.br
\fIfirst\fP List item in \fCxlist\fP marking the start of elements to be copied into \fCthislist\fP 
.br
\fIlast\fP List item in \fCxlist\fP marking the end of elements to be copied into \fCthislist\fP 
.RE
.PP
Splice a subset of a list into another list. The \fC\fP[first, last) elements of \fCxlist\fP are moved into \fCthislist\fP, inserting them before \fCpos\fP. \fCpos\fP must be a valid iterator in \fCthislist\fP and \fC\fP[first, last) must be a valid range in \fCxlist\fP. \fCpostition\fP must not be in the range \fC\fP[first, last). It is, however, valid for \fCxlist\fP and \fCthislist\fP to be the same list.
.PP
This is an O(N) operation because the length of both lists must be recomputed. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
